/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of HighwayHash.xs. Do not edit this file, edit HighwayHash.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "HighwayHash.xs"
#define PERL_NO_GET_CONTEXT
#define MATH_INT64_NATIVE_IF_AVAILABLE
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "perl_math_int64.h"
#include "ppport.h"

#include "highwayhash.c"

typedef HighwayHashCat* Digest__HighwayHash;

void process_key(pTHX_ AV *key_av, uint64_t *key) {
	int i;
	SV *elt;

	if(av_len(key_av) + 1 != 4)
		croak("Key for highway_hash must be a 4-element array");
	for(i = 0 ; i < 4 ; i++) {
		elt = *av_fetch(key_av, i, 0);
		if(SvU64OK(elt))
			key[i] = SvU64(elt);
		else
			key[i] = SvUV(elt);
	}
}

uint64_t highway_hash64(AV *key_av, unsigned char *bytes, size_t size) {
	dTHX;
	uint64_t key[4];
	process_key(aTHX_ key_av, key);
	return HighwayHash64(bytes, size, key);
}

AV* highway_hash128(AV *key_av, unsigned char *bytes, size_t size) {
	dTHX;
	AV* result;
	uint64_t key[4];
	uint64_t hash[2];
	process_key(aTHX_ key_av, key);
	HighwayHash128(bytes, size, key, hash);
	result = newAV();
	av_push(result, sv_2mortal(newSVu64(hash[0])));
	av_push(result, sv_2mortal(newSVu64(hash[1])));
	return result;
}

AV* highway_hash256(AV *key_av, unsigned char *bytes, size_t size) {
	dTHX;
	AV* result;
	uint64_t key[4];
	uint64_t hash[4];
	process_key(aTHX_ key_av, key);
	HighwayHash256(bytes, size, key, hash);
	result = newAV();
	av_push(result, sv_2mortal(newSVu64(hash[0])));
	av_push(result, sv_2mortal(newSVu64(hash[1])));
	av_push(result, sv_2mortal(newSVu64(hash[2])));
	av_push(result, sv_2mortal(newSVu64(hash[3])));
	return result;
}

Digest__HighwayHash new(AV *key_av) {
	dTHX;
	uint64_t key[4];
	Digest__HighwayHash state;
	Newx(state, 1, HighwayHashCat);
	process_key(aTHX_ key_av, key);
	HighwayHashCatStart(key, state);
	return state;
}

void append(Digest__HighwayHash state, unsigned char *bytes, size_t size) {
	HighwayHashCatAppend(bytes, size, state);
}

uint64_t finish64(Digest__HighwayHash state) {
	return HighwayHashCatFinish64(state);
}

AV* finish128(Digest__HighwayHash state) {
	dTHX;
	AV* result;
	uint64_t hash[2];
	HighwayHashCatFinish128(state, hash);
	result = newAV();
	av_push(result, sv_2mortal(newSVu64(hash[0])));
	av_push(result, sv_2mortal(newSVu64(hash[1])));
	return result;
}

AV* finish256(Digest__HighwayHash state) {
	dTHX;
	AV* result;
	uint64_t hash[4];
	HighwayHashCatFinish256(state, hash);
	result = newAV();
	av_push(result, sv_2mortal(newSVu64(hash[0])));
	av_push(result, sv_2mortal(newSVu64(hash[1])));
	av_push(result, sv_2mortal(newSVu64(hash[2])));
	av_push(result, sv_2mortal(newSVu64(hash[3])));
	return result;
}

#line 116 "HighwayHash.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 260 "HighwayHash.c"

XS_EUPXS(XS_Digest__HighwayHash_highway_hash64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_highway_hash64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "key_av, bytes");
    {
	uint64_t	RETVAL;
	STRLEN	STRLEN_length_of_bytes;
	size_t	XSauto_length_of_bytes;
	AV *	key_av;
	unsigned char *	bytes = (unsigned char *)SvPV(ST(1), STRLEN_length_of_bytes);

	XSauto_length_of_bytes = STRLEN_length_of_bytes;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    key_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Digest::HighwayHash::highway_hash64",
				"key_av");
		}
	} STMT_END
;

	RETVAL = highway_hash64(key_av, bytes, XSauto_length_of_bytes);
	{
	    SV * RETVALSV;
	    RETVALSV = newSVu64(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_highway_hash128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_highway_hash128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "key_av, bytes");
    {
	AV *	RETVAL;
	STRLEN	STRLEN_length_of_bytes;
	size_t	XSauto_length_of_bytes;
	AV *	key_av;
	unsigned char *	bytes = (unsigned char *)SvPV(ST(1), STRLEN_length_of_bytes);

	XSauto_length_of_bytes = STRLEN_length_of_bytes;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    key_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Digest::HighwayHash::highway_hash128",
				"key_av");
		}
	} STMT_END
;

	RETVAL = highway_hash128(key_av, bytes, XSauto_length_of_bytes);
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_highway_hash256); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_highway_hash256)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "key_av, bytes");
    {
	AV *	RETVAL;
	STRLEN	STRLEN_length_of_bytes;
	size_t	XSauto_length_of_bytes;
	AV *	key_av;
	unsigned char *	bytes = (unsigned char *)SvPV(ST(1), STRLEN_length_of_bytes);

	XSauto_length_of_bytes = STRLEN_length_of_bytes;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    key_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Digest::HighwayHash::highway_hash256",
				"key_av");
		}
	} STMT_END
;

	RETVAL = highway_hash256(key_av, bytes, XSauto_length_of_bytes);
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, key_av");
    {
	Digest__HighwayHash	RETVAL;
	SV *	class = ST(0)
;
	AV *	key_av;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    key_av = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Digest::HighwayHash::new",
				"key_av");
		}
	} STMT_END
;

	RETVAL = new(key_av);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Digest::HighwayHash", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_append)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, bytes");
    {
	STRLEN	STRLEN_length_of_bytes;
	size_t	XSauto_length_of_bytes;
	Digest__HighwayHash	state;
	unsigned char *	bytes = (unsigned char *)SvPV(ST(1), STRLEN_length_of_bytes);

	XSauto_length_of_bytes = STRLEN_length_of_bytes;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::HighwayHash")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    state = INT2PTR(Digest__HighwayHash,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::HighwayHash::append",
			"state", "Digest::HighwayHash")
;

	append(state, bytes, XSauto_length_of_bytes);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Digest__HighwayHash_finish64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_finish64)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	uint64_t	RETVAL;
	Digest__HighwayHash	state;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::HighwayHash")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    state = INT2PTR(Digest__HighwayHash,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::HighwayHash::finish64",
			"state", "Digest::HighwayHash")
;

	RETVAL = finish64(state);
	{
	    SV * RETVALSV;
	    RETVALSV = newSVu64(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_finish128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_finish128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	AV *	RETVAL;
	Digest__HighwayHash	state;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::HighwayHash")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    state = INT2PTR(Digest__HighwayHash,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::HighwayHash::finish128",
			"state", "Digest::HighwayHash")
;

	RETVAL = finish128(state);
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Digest__HighwayHash_finish256); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Digest__HighwayHash_finish256)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "state");
    {
	AV *	RETVAL;
	Digest__HighwayHash	state;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Digest::HighwayHash")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    state = INT2PTR(Digest__HighwayHash,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Digest::HighwayHash::finish256",
			"state", "Digest::HighwayHash")
;

	RETVAL = finish256(state);
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Digest__HighwayHash); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Digest__HighwayHash)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Digest::HighwayHash::highway_hash64", XS_Digest__HighwayHash_highway_hash64);
        newXS_deffile("Digest::HighwayHash::highway_hash128", XS_Digest__HighwayHash_highway_hash128);
        newXS_deffile("Digest::HighwayHash::highway_hash256", XS_Digest__HighwayHash_highway_hash256);
        newXS_deffile("Digest::HighwayHash::new", XS_Digest__HighwayHash_new);
        newXS_deffile("Digest::HighwayHash::append", XS_Digest__HighwayHash_append);
        newXS_deffile("Digest::HighwayHash::finish64", XS_Digest__HighwayHash_finish64);
        newXS_deffile("Digest::HighwayHash::finish128", XS_Digest__HighwayHash_finish128);
        newXS_deffile("Digest::HighwayHash::finish256", XS_Digest__HighwayHash_finish256);

    /* Initialisation Section */

#line 109 "HighwayHash.xs"
     PERL_MATH_INT64_LOAD_OR_CROAK;

#line 590 "HighwayHash.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

